/**
 * oscP5broadcastClient by andreas schlegel
 * an osc broadcast client.
 * an example for broadcast server is located in the oscP5broadcaster exmaple.
 * oscP5 website at http://www.sojamo.de/oscP5
 */

import oscP5.*;
import netP5.*;

String incoming;

OscP5 oscP5;

/* a NetAddress contains the ip address and port number of a remote location in the network. */
NetAddress myBroadcastLocation; 
String x = ":D";
String textBox = "/1/textdisplay-1";
String[] textDisplay1 = new String[70];
String[] textDisplay2 = new String[70];
String[] textDisplay3 = new String[70];
String[] textDisplay4 = new String[70];

int textLocation1;
int textLocation2;
int textLocation3;
int textLocation4;

String textDisplayStr1;
String textDisplayStr2;
String textDisplayStr3;
String textDisplayStr4;

void setup() {
  size(400,400);
  frameRate(25);
  oscP5 = new OscP5(this,6668); //incoming
  
  /* create a new NetAddress. a NetAddress is used when sending osc messages
   * with the oscP5.send method. 127.0.0.1
   */
   
  /* the address of the osc broadcast server */
  myBroadcastLocation = new NetAddress("192.168.1.100",9000); //ipad ip and outgoing>ingoing
}


void draw() {
  background(0);
}


void mousePressed() {
  if(x.equals(":D")){
    x=";)";
  }
  else{
    x=":D";
  }
  /* create a new OscMessage with an address pattern, in this case /test. */
  OscMessage myOscMessage = new OscMessage("/1/textdisplay-1/position/x");
  /* add a value (an integer) to the OscMessage */
  myOscMessage.add(0);
  /* send the OscMessage to a remote location specified in myNetAddress */
  oscP5.send(myOscMessage, myBroadcastLocation);
  println("moused pressed");
}


/* incoming osc message are forwarded to the oscEvent method. */
void oscEvent(OscMessage theOscMessage) {
  /* get and print the address pattern and the typetag of the received OscMessage */
  println("### received an osc message with addrpattern "+theOscMessage.addrPattern()+" and typetag "+theOscMessage.typetag());
  theOscMessage.print();
  String oscIn = theOscMessage.addrPattern();     //  Creates a string out of the OSC message
  int locationOfSub = oscIn.indexOf("-");         // Find the location of seperation of the message
  String oscInFirst = oscIn.substring(3,locationOfSub);  // Create a string for the first part
  String oscInSecond = oscIn.substring(locationOfSub+1,oscIn.length());
  println(oscInFirst);
  println(oscInSecond);
  
  float oscValue = theOscMessage.get(0).floatValue();
  
  if(oscInFirst.equals("textbox") && oscValue==1.0){
    if(oscInSecond.equals("1")){
      textBox = "/1/textdisplay-1";
    }
    if(oscInSecond.equals("2")){
      textBox = "/1/textdisplay-2";
    }
    if(oscInSecond.equals("3")){
      textBox = "/1/textdisplay-3";
    }
    if(oscInSecond.equals("4")){
      textBox = "/1/textdisplay-4";
    }
    println(textBox);
  }
 
  if(oscInFirst.equals("keyboard") && oscValue==1.0){
    if(textBox.equals("/1/textdisplay-1")){
      textDisplay1[textLocation1] = oscInSecond;
      textLocation1++;
      textDisplayStr1 = join(textDisplay1,"");
      textDisplayStr1 = textDisplayStr1.substring(0,textLocation1);
      OscMessage OSCtextbox1 = new OscMessage("/1/textdisplay-1");
      OSCtextbox1.add(textDisplayStr1);
      oscP5.send(OSCtextbox1, myBroadcastLocation);
    }
    if(textBox.equals("/1/textdisplay-2")){
      textDisplay2[textLocation2] = oscInSecond;
      textLocation2++;
      textDisplayStr2 = join(textDisplay2,"");
      textDisplayStr2 = textDisplayStr2.substring(0,textLocation2);
      OscMessage OSCtextbox2 = new OscMessage("/1/textdisplay-2");
      OSCtextbox2.add(textDisplayStr2);
      oscP5.send(OSCtextbox2, myBroadcastLocation);
    
    }
    if(textBox.equals("/1/textdisplay-3")){
      textDisplay3[textLocation3] = oscInSecond;
      textLocation3++;
      textDisplayStr3 = join(textDisplay3,"");
      textDisplayStr3 = textDisplayStr3.substring(0,textLocation3);  
      OscMessage OSCtextbox3 = new OscMessage("/1/textdisplay-3");
      OSCtextbox3.add(textDisplayStr3);
      oscP5.send(OSCtextbox3, myBroadcastLocation);    
    }
    if(textBox.equals("/1/textdisplay-4")){
      textDisplay4[textLocation4] = oscInSecond;
      textLocation4++;
      textDisplayStr4 = join(textDisplay4,"");
      textDisplayStr4 = textDisplayStr4.substring(0,textLocation4);  
      OscMessage OSCtextbox4 = new OscMessage("/1/textdisplay-4");
      OSCtextbox4.add(textDisplayStr4);
      oscP5.send(OSCtextbox4, myBroadcastLocation);   
    }
  }
  
  if(oscInFirst.equals("function") && oscInSecond.equals("delete") && oscValue==1.0){
    if(textBox.equals("/1/textdisplay-1") && textLocation1>=1){
      textDisplay1[textLocation1] = "";
      textLocation1--;
      textDisplayStr1 = join(textDisplay1,"");
      textDisplayStr1 = textDisplayStr1.substring(0,textLocation1);
      OscMessage OSCtextbox1 = new OscMessage("/1/textdisplay-1");
      OSCtextbox1.add(textDisplayStr1);
      oscP5.send(OSCtextbox1, myBroadcastLocation);
    }
    if(textBox.equals("/1/textdisplay-2") && textLocation2>=1){
      textDisplay2[textLocation2] = "";
      textLocation2--;
      textDisplayStr2 = join(textDisplay2,"");
      textDisplayStr2 = textDisplayStr2.substring(0,textLocation2);
      OscMessage OSCtextbox2 = new OscMessage("/1/textdisplay-2");
      OSCtextbox2.add(textDisplayStr2);
      oscP5.send(OSCtextbox2, myBroadcastLocation);
    }
    if(textBox.equals("/1/textdisplay-3") && textLocation3>=1){
      textDisplay3[textLocation3] = "";
      textLocation3--;
      textDisplayStr3 = join(textDisplay3,"");
      textDisplayStr3 = textDisplayStr3.substring(0,textLocation3);     
      OscMessage OSCtextbox3 = new OscMessage("/1/textdisplay-3");
      OSCtextbox3.add(textDisplayStr3);
      oscP5.send(OSCtextbox3, myBroadcastLocation); 
    }
    if(textBox.equals("/1/textdisplay-4") && textLocation4>=1){
      textDisplay4[textLocation4] = "";
      textLocation4--;
      textDisplayStr4 = join(textDisplay4,"");
      textDisplayStr4 = textDisplayStr4.substring(0,textLocation4);   
      OscMessage OSCtextbox4 = new OscMessage("/1/textdisplay-4");
      OSCtextbox4.add(textDisplayStr4);
      oscP5.send(OSCtextbox4, myBroadcastLocation);  
    }
 
  }
  
  if(oscInFirst.equals("function") && oscInSecond.equals("space") && oscValue==1.0){
    if(textBox.equals("/1/textdisplay-1")){
      textDisplay1[textLocation1] = " ";
      textLocation1++;
      textDisplayStr1 = join(textDisplay1,"");
      textDisplayStr1 = textDisplayStr1.substring(0,textLocation1);
      OscMessage OSCtextbox1 = new OscMessage("/1/textdisplay-1");
      OSCtextbox1.add(textDisplayStr1);
      oscP5.send(OSCtextbox1, myBroadcastLocation);
    }
    if(textBox.equals("/1/textdisplay-2")){
      textDisplay2[textLocation2] = " ";
      textLocation2++;
      textDisplayStr2 = join(textDisplay2,"");
      textDisplayStr2 = textDisplayStr2.substring(0,textLocation2);      
      OscMessage OSCtextbox2 = new OscMessage("/1/textdisplay-2");
      OSCtextbox2.add(textDisplayStr2);
      oscP5.send(OSCtextbox2, myBroadcastLocation);
    }
    if(textBox.equals("/1/textdisplay-3")){
      textDisplay3[textLocation3] = " ";
      textLocation3++;
      textDisplayStr3 = join(textDisplay3,"");
      textDisplayStr3 = textDisplayStr3.substring(0,textLocation3);     
      OscMessage OSCtextbox3 = new OscMessage("/1/textdisplay-3");
      OSCtextbox3.add(textDisplayStr3);
      oscP5.send(OSCtextbox3, myBroadcastLocation);   
    }
    if(textBox.equals("/1/textdisplay-4")){
      textDisplay4[textLocation4] = " ";
      textLocation4++;
      textDisplayStr4 = join(textDisplay4,"");
      textDisplayStr4 = textDisplayStr4.substring(0,textLocation4);     
      OscMessage OSCtextbox4 = new OscMessage("/1/textdisplay-4");
      OSCtextbox4.add(textDisplayStr4);
      oscP5.send(OSCtextbox4, myBroadcastLocation);
    }
  }
  
}
